options /c /wl=&1FF8 /wp=&1ffe /ws=512

*** copy file
  ** fnsrc (string) name (path) of source file
  ** fndest (string) name (path) of destination file
  ** returns 1 on succcess, 0 on error
subroutine copyFile(fnsrc,fndest)
integer fnsrc
integer fndest
   integer fp1, fp2, pbuf
   character buf
   buf = str$(%50X 0) : * make buffer of 50 characters
   pbuf = dpeek(loc(buf))
   
   /push dx
   /push cx
   * create destination file
   /mov dx, fndest
   /mov cx, 0
   /mov ah, &3c
   /int &21
   /pop cx
   /jnc @destok
   /pop dx
   print "Creation of destination file failed."
   return 0
   @destok
   fp2 = !
   * open source file
   /mov dx, fnsrc
   /mov ax, &3d00
   /int &21
   /pop dx
   /jnc @srcok
   * close fp2
   /push bx
   /mov bx, fp2
   /mov ah, &3e
   /int &21
   /pop bx
   print "Failed to open source file."
   return 0
   @srcok
   fp1 = !
   * do copy
   /push dx
   /push cx
   /push bx
   @cpyloop
   /mov cx, 50
   /mov ah, &3f
   /mov bx, fp1
   /mov dx, pbuf
   /int &21
   /jc @cpyend
   /cmp ax, 0
   /jz @cpyend
   /mov cx, ax
   /mov dx, pbuf
   /mov ah, &40
   /mov bx, fp2
   /int &21
   /jc @cpyend
   /cmp cx, 50
   /jz @cpyloop
   @cpyend
   * close fp1
   /mov ah, &3e
   /mov bx, fp1
   /int &21
   *close fp2
   /mov ah, &3e
   /mov bx, fp2
   /int &21
   /pop bx
   /pop cx
   /pop dx
return 1
subend

*** patches compiled TBC file
  ** fname (string) name of file to patch
  ** isExe (integer) flag: 0 means file is in COM format, other value means EXE format
  ** returns 1 on succcess, 0 on error
subroutine patchFile(fname,isExe)
integer fname
integer isExe
   integer fp
   integer offs1, offs2, result, patchbuf
   dim patchbuf(1)
   * open file
   /push dx
   /mov dx, fname
   /mov ax, &3d02
   /int &21
   /pop dx
   /jnc @openok
   * close fp
   /push bx
   /mov bx, fp2
   /mov ah, &3e
   /int &21
   /pop bx
   print "Failed to open file."
   return 0
   @openok
   result = 1
   fp = !
   if isExe = 0 then
      offs1 = &b8
      offs2 = &dc
   else
      offs1 = &d8
      offs2 = &fc
   endif
   /push bx
   /push cx
   /push dx
   /mov bx, fp
   /xor cx, cx
   /mov dx, offs1
   /mov ax, &4200
   /int &21
   /jc @patcherr
   /mov bx, fp
   /mov dx, offset patchbuf(0)
   /mov cx, 2
   /mov ah, &3f
   /int &21
   /jc @patcherr
   /mov bx, fp
   /xor cx, cx
   /mov dx, offs2
   /mov ax, &4200
   /int &21
   /jc @patcherr
   /mov bx, fp
   /mov dx, offset patchbuf(1)
   /mov cx, 2
   /mov ah, &3f
   /int &21
   /jc @patcherr
   patchbuf(1) = patchbuf(1) - &1000
   patchbuf(1) = patchbuf(1) + patchbuf(0) 
   /mov bx, fp
   /xor cx, cx
   /mov dx, offs2
   /mov ax, &4200
   /int &21
   /jc @patcherr
   /mov bx, fp
   /mov dx, offset patchbuf(1)
   /mov cx, 2
   /mov ah, &40
   /int &21
   /jnc @patchok   
   @patcherr
   result = 0
   @patchok
   /pop dx
   /pop cx
   /mov bx, fp
   /mov ah, &3e
   /int &21
   return result
subend

character args
dim args(1)
integer argcnt, pspseg, parg, c, l, i 

/mov ax, cs
/mov pspseg, ax
#e pspseg = pspseg-16
parg = &81

argcnt = 0

args(0) = ""
args(1) = ""
l = 0
i = 0
while peek(pspseg; parg)<>&d
  c = !
  if c=' ' then
     if argcnt = 2 then 
       break
     else
        if l>0 then l=0
     endif
  else
     if l=0 then i = argcnt : argcnt = argcnt+1
     l=l+1
     if c >= 'a' then
        if c <= 'z' then c = c- &20 :* make c uppercase
     endif
     args(i) = args(i) + chr$(c)
  endif
  parg=parg+1
wend

if argcnt < 1 then
   print "usage: tbcptch infile[.com] [outfile]"
   goto end
endif

buf$ =  right$(args(0),4)
integer isExe
isExe = 0
if asc(buf$) = '.' then
   if buf$ = ".EXE" then isExe = 1
else 
   args(0) = args(0) + ".COM"
endif
if argcnt = 2 then
   if call_copyFile(args(0),args(1)) = 0 then goto end
   args(0) = args(1)
endif
   call patchFile(args(0),isExe)
@end
end
